﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Jewels
{
    public partial class Form1 : Form
    {
        string filename;
        int color1, color2;
        int timeleft = 300;
        int score = 0;
        bool gameStarted = false;
        bool firstClick = true;
        Label2 last;
        Label2[,] pole = new Label2[8, 8];
        Label2[] queue = new Label2[8];
        Queue<int>[] fronta = new Queue<int>[8];
        Point first, second;

        public Form1()
        {
            InitializeComponent();
            createBoard();
        }

        private void createBoard()
        {
            for(int x = 0; x < 8; x++)
            {
                for(int y = 0; y < 8; y++)
                {
                    Label2 label = new Label2(x, y);
                    gamePanel.Controls.Add(label);
                    label.Location = new Point(32 * x, 32 * y);
                    label.Size = new Size(32, 32);
                    //label.BorderStyle = BorderStyle.FixedSingle;
                    label.Click += new EventHandler(label_Click);

                    pole[x, y] = label;
                }
            }

            for(int x = 0; x < 8; x++)
            {
                Label2 label = new Label2(x, -1);
                queuePanel.Controls.Add(label);
                label.Location = new Point(32 * x, 0);
                label.Size = new Size(32, 32);
                queue[x] = label;
            }
        }

        private void label_Click(object sender, EventArgs e)
        {
            if (gameStarted)
            {
                Label2 label = (Label2)sender;
                //MessageBox.Show(String.Format("X: {0}, Y: {1}", label.X, label.Y));
                label.BorderStyle = BorderStyle.FixedSingle;
                if (firstClick) {
                    firstClick = false;
                    last = label;
                }
                else
                {
                    if((Math.Abs(last.X - label.X) == 1 && last.Y - label.Y == 0) || (last.X - label.X == 0 && Math.Abs(last.Y - label.Y) == 1))
                    {
                        if (prohodDva(last, label)) {
                            jeSled();
                        }
                        firstClick = true;
                    }
                    else
                    {
                        last.BorderStyle = BorderStyle.None;
                        label.BorderStyle = BorderStyle.None;
                        firstClick = true;
                    }
                }
            }
        }

        private bool prohodDva(Label2 first, Label2 second, bool test = false)
        {
            int color = first.Color;
            first.Color = second.Color;
            second.Color = color;
            if (!test)
            {
                first.BorderStyle = BorderStyle.None;
                second.BorderStyle = BorderStyle.None;
            }
            if(jeSled(test))
            {
                if(test)
                    color = first.Color;
                    first.Color = second.Color;
                    second.Color = color;
                return true;
            }
            else
            {
                color = first.Color;
                first.Color = second.Color;
                second.Color = color;
                return false;
            }
        }

        private bool jeSled(bool test = false)
        {
            List<Sled> sledy = new List<Sled>();
            for(int xxx = 2; xxx < 8; xxx++)
            {
                for(int yyy = 0; yyy < 8; yyy++)
                {
                    if(pole[xxx, yyy].Color == pole[xxx - 1, yyy].Color && pole[xxx, yyy].Color == pole[xxx - 2, yyy].Color)
                    {
                        sledy.Add(new Sled(xxx - 2, yyy));
                        sledy.Add(new Sled(xxx - 1, yyy));
                        sledy.Add(new Sled(xxx, yyy));
                    }
                }
            }
            for(int yyy = 2; yyy < 8; yyy++)
            {
                for(int xxx = 0; xxx < 8; xxx++)
                {
                    if (pole[xxx, yyy].Color == pole[xxx, yyy - 1].Color && pole[xxx, yyy].Color == pole[xxx, yyy - 2].Color)
                    {
                        sledy.Add(new Sled(xxx, yyy - 2));
                        sledy.Add(new Sled(xxx, yyy - 1));
                        sledy.Add(new Sled(xxx, yyy));
                    }
                }
            }
            if (sledy.Count == 0)
            {
                return false;
            }
            else {
                if (!test)
                {
                    odstranSledy(sledy);
                    jeSled();
                }
                return true;
            }
        }

        private List<Tuple<Point, Point>> jesledmozny()
        {
            List<Tuple<Point, Point>> sledy = new List<Tuple<Point, Point>>();
            for(int x = 1; x < 7; x ++)
            {
                for(int y = 1; y < 7; y ++)
                {
                    if(prohodDva(pole[x, y], pole[x - 1, y], true)) {
                        sledy.Add(new Tuple<Point, Point>(new Point(x, y), new Point(x - 1, y)));
                    }
                    if (prohodDva(pole[x, y], pole[x + 1, y], true)) {
                        sledy.Add(new Tuple<Point, Point>(new Point(x, y), new Point(x + 1, y)));
                    }
                    if (prohodDva(pole[x, y], pole[x, y - 1], true)) {
                        sledy.Add(new Tuple<Point, Point>(new Point(x, y), new Point(x, y - 1)));
                    }
                    if (prohodDva(pole[x, y], pole[x, y + 1], true)) {
                        sledy.Add(new Tuple<Point, Point>(new Point(x, y), new Point(x, y + 1)));
                    }
                }
            }
            return sledy;
        }

        private void odstranSledy(List<Sled> sledy)
        {
            List<Sled> unikatnisledy = new List<Sled>();
            int skoreTahu = 0;
            for(int x = 0; x < 8; x++)
            {
                for(int y = 0; y < 8; y++)
                {
                    foreach(Sled sled in sledy)
                    {
                        bool first = true;
                        if(sled.X == x && sled.Y == y)
                        {
                            skoreTahu++;
                            if(first)
                            {
                                unikatnisledy.Add(sled);
                            }
                            first = false;
                        }
                    }
                }
            }
            score += skoreTahu;
            scoreLabel.Text = score.ToString();
            unikatnisledy.OrderByDescending(x => x.Y);
            foreach(Sled usled in unikatnisledy)
            {
                int color = fronta[usled.X].Dequeue();
                fronta[usled.X].Enqueue(color); 
                for(int y = usled.Y; y > 0; y--)
                {
                    pole[usled.X, y].Color = pole[usled.X, y - 1].Color;
                }
                pole[usled.X, 0].Color = color;
            }
            for(int i = 0; i < 8; i++)
                queue[i].Color = fronta[i].First();
            //jeSled();
            //MessageBox.Show(jeSled().ToString());
            if (jesledmozny().Count == 0)
                gameOver();
        }

        private void browseButton_Click(object sender, EventArgs e)
        {
            if(openFileDialog.ShowDialog() == DialogResult.OK)
            {
                filename = openFileDialog.FileName;
                if(File.Exists(filename))
                {
                    chosenFile.Text = Path.GetFileName(filename);
                    startButton.Enabled = true;
                }
            }
        }

        private void loadBoard(string filename)
        {
            if (File.Exists(filename))
            {
                try {
                    string text = File.ReadAllText(filename);
                    string[] lines = text.Split('\n');
                    for (int x = 0; x < 8; x++)
                    {
                        for (int y = 0; y < 8; y++)
                        {
                            int colorNumber = int.Parse(lines[x][y].ToString());
                            pole[x, y].Color = colorNumber;
                        }
                    }
                    for (int x = 0; x < 8; x++)
                    {
                        fronta[x] = new Queue<int>();
                        for (int y = 0; y < lines[x + 8].Length - 1; y++)
                        {
                            int color = int.Parse(lines[x + 8][y].ToString());
                            fronta[x].Enqueue(color);
                        }
                        queue[x].Color = fronta[x].First();
                    }
                }
                catch (FormatException e)
                {
                    MessageBox.Show("Soubor je poškozen, a nemusel se načíst správně.");
                }
            }
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            startHry();
        }

        private void startHry()
        {
            score = 0;
            scoreLabel.Text = "0";
            Label2[] queue = new Label2[8];
            Queue<int>[] fronta = new Queue<int>[8];
            startButton.Enabled = false;
            stopButton.Enabled = true;
            checkBox1.Enabled = false;
            hintButton.Enabled = true;
            gameStarted = true;
            if (checkBox1.Checked)
            {
                timeleft = int.Parse(minutesTextbox.Text) * 60 + int.Parse(secondsTextBox.Text);
                timer1.Start();
                minutesTextbox.Enabled = false;
                secondsTextBox.Enabled = false;
            }
            loadBoard(filename);
            if (jesledmozny().Count == 0)
                gameOver();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if(checkBox1.Checked)
            {
                minutesTextbox.Enabled = true;
                secondsTextBox.Enabled = true;
            }
            else
            {
                minutesTextbox.Enabled = false;
                secondsTextBox.Enabled = false;
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            timeleft--;
            int minutes = timeleft / 60;
            int seconds = timeleft % 60;
            if(minutes / 10 < 1) 
                minutesTextbox.Text = "0" + minutes.ToString();
            else
                minutesTextbox.Text = minutes.ToString();
            if(seconds / 10 < 1)
                secondsTextBox.Text = "0" + seconds.ToString();
            else
                secondsTextBox.Text = seconds.ToString();
            if (timeleft == 0)
            {
                gameOver();
            }
        }

        private void gameOver()
        {
            timer1.Stop();
            hintButton.Enabled = false;
            gameStarted = false;
            startButton.Enabled = true;
            stopButton.Enabled = false;
            checkBox1.Enabled = true;
            MessageBox.Show("Konec hry, tvé výsledné skóre je " + score + ".");
            if (checkBox1.Checked)
            {
                minutesTextbox.Enabled = true;
                secondsTextBox.Enabled = true;
            }
            else
            {
                minutesTextbox.Enabled = false;
                secondsTextBox.Enabled = false;
            }
        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            gameOver();
        }

        private void hintButton_Click(object sender, EventArgs e)
        {
            hint();
        }

        private void minutesTextbox_TextChanged(object sender, EventArgs e)
        {
            /*int cislo = 5;
            int.TryParse(minutesTextbox.Text, out cislo);

            /*if (cislo < 0)
                cislo = 0;
            int minutes = cislo / 60;
            if (minutes / 10 < 2)
                minutesTextbox.Text = "0" + minutes.ToString();
            else*/
              //  minutesTextbox.Text = cislo.ToString();
        }

        private void secondsTextBox_TextChanged(object sender, EventArgs e)
        {
            /*int cislo = 0;
            int.TryParse(secondsTextBox.Text, out cislo);
            /*if (cislo >= 60)
                cislo = 59;
            if (cislo < 0)
                cislo = 0;
            int seconds = cislo % 60;
            if (seconds / 10 < 2)
                secondsTextBox.Text = "0" + seconds.ToString();
            else*/
              //  secondsTextBox.Text = cislo.ToString();
        }

        private void hint()
        {
            List<Tuple<Point, Point>> seznam = jesledmozny();
            Random rand = new Random();
            int random = rand.Next(seznam.Count);
            first = seznam[random].Item1;
            second = seznam[random].Item2;
            color1 = pole[first.X, first.Y].Color;
            color2 = pole[second.X, second.Y].Color;
            pole[first.X, first.Y].BackColor = Color.Silver;
            pole[second.X, second.Y].BackColor = Color.Silver;
            timer2.Start();
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            pole[first.X, first.Y].Color = color1;
            pole[second.X, second.Y].Color = color2;
            timer2.Stop();
        }
    }

    public class Sled
    {
        public int X, Y;
        /*public enum Smer {Svisle, Vodorovne};
        /*public Smer smer;*/
        
        public Sled(int x, int y)
        {
            this.X = x;
            this.Y = y;
            //this.smer = smer;
        }
    }

    public class Label2 : Label
    {
        public int X, Y;
        private int color;

        public Label2(int x, int y)
        {
            this.X = x;
            this.Y = y;
        }

        public int Color
        {
            get { return this.color; }
            set
            {
                this.color = value;
                switch (value)
                {
                    case 1:
                        this.BackColor = System.Drawing.Color.Red;
                        break;
                    case 2:
                        this.BackColor = System.Drawing.Color.Green;
                        break;
                    case 3:
                        this.BackColor = System.Drawing.Color.Blue;
                        break;
                    case 4:
                        this.BackColor = System.Drawing.Color.White;
                        break;
                    case 5:
                        this.BackColor = System.Drawing.Color.Yellow;
                        break;
                    case 6:
                        this.BackColor = System.Drawing.Color.Violet;
                        break;
                }
            }
        }
    }
}
